<!DOCTYPE html>
<html lang="en">
<head>
    <title>Update User</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
    <div class="container jumbotron">
        <div class="text-center mb-4">
            <h3>Chi tiết user</h3>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>First Name</label>
            </div>
            <div class="col-sm-8">
                <input class="form-control" id="inp-firstname" type="text" placeholder="Nhập First Name...">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Last Name</label>
            </div>
            <div class="col-sm-8">
                <input class="form-control" id="inp-lastname" type="text" placeholder="Nhập Last Name...">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Subject</label>
            </div>
            <div class="col-sm-8">
                <input class="form-control" id="inp-subject" type="text" placeholder="Nhập Subject...">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Country</label>
            </div>
            <div class="col-sm-8">
                <select class="form-control" id="select-country" name="country">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Customer Type</label>
            </div>
            <div class="col-sm-8">
                <select class="form-control" id="select-customer" name="customertype">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Register Status</label>
            </div>
            <div class="col-sm-8">
                <select class="form-control" id="select-register" name="register">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">

            </div>
            <div class="col-sm-8">
                <button type="button" class="btn btn-success w-25" id="btn-update">Update User</button>
                <button type="button" class="btn btn-success w-25">Hủy bỏ</button>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    //REGION 1
        var gElementFirstName = $("#inp-firstname");
        var gElementLastName = $("#inp-lastname");
        var gElementSubject = $("#inp-subject");
        var gElementCountry = $("#select-country");
        var gElementCustomerType = $("#select-customer");
        var gElementRegisterStatus = $("#select-register");
    //REGION 2
    $(document).ready(function(){
        onPageLoading();
        //gán sự kiện nút ấn UpdateUser
        $("#btn-update").on("click", function(){
            onBtnUpdateUserClick(this);
        })
    });
    //REGION 3
    //hàm load trang 
    function onPageLoading(){
        //thu thập dữ liệu từ QueryString
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
         var vId = vUrl.searchParams.get("id");
         console.log("id: " + vId);
         callApiGetUserById(vId);
    }
    //hàm xử lý sự kiện nút update user được ấn
    function onBtnUpdateUserClick(){
        console.log("nút update user được ấn");
        //b1 khai báo obj lưu dữ liệu, thu thập dữ liệu 
        var vGetDataUserObj = getDataUserToForm()
        //b2: kiểm tra dữ liệu
        var vIsCheck = valiDataUserObj(vGetDataUserObj)
        if(vIsCheck){
            //b3 gọi api
            callApiUpdateUserObj(vGetDataUserObj);
            //b4 hiển thị thông tin
        }
        
    }
    //REGION 4
    //hàm thu thập dữ liệu trên form
    function getDataUserToForm(){
       var vUpdateInfoObj = new Object();
       vUpdateInfoObj.firstname = $.trim(gElementFirstName.val());
       vUpdateInfoObj.lastname = $.trim(gElementLastName.val());
       vUpdateInfoObj.subject = $.trim(gElementSubject.val());
       vUpdateInfoObj.country = gElementCountry.val();
       vUpdateInfoObj.customerType = gElementCustomerType.val();
       vUpdateInfoObj.registerStatus = gElementRegisterStatus.val();

       return vUpdateInfoObj;
    }
    //hàm kiểm tra dữ liệu
    function valiDataUserObj(paramUserObj){
        if(paramUserObj.firstname == ""){
            alert("Bạn chưa nhập first name");
            $("#inp-firstname").focus()
            return false;
        }
        if(paramUserObj.lastname == ""){
            alert("Bạn chưa nhập last name");
            $("#inp-lastname").focus();
            return false;
        }
        if(paramUserObj.subject == ""){
            alert("Bạn chưa nhập subject");
            $("#inp-subject").focus();
            return false;
        }
        if(paramUserObj.country == ""){
            alert("Bạn chưa chọn country");
            $("#select-country").focus();
            return false;
        }
        if(paramUserObj.customerType == ""){
            alert("Bạn chưa chọn customerType");
            $("#select-customer").focus();
            return false;
        }
        if(paramUserObj.registerStatus == ""){
            alert("Bạn chưa chọn RegisterStatus");
            $("#select-register").focus();
            return false;
        }
        return true;
    }
    //hàm ajax put api để update user
    function callApiUpdateUserObj(paramDataUser){
        "use strict";
        //b1 get data user id
        var vUserId = getCurrentUserId()
        var vJsonString = JSON.stringify(paramDataUser);
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + vUserId,
            type: "PUT",
            contentType: "application/json; charset=UTF-8", 
            data: vJsonString,
            success: function(paramResponse){
                alert("User Id: " + paramResponse.id + "\n cập nhật thông tin thành công!");
                //khi cập nhật thành công quay lại thông tin danh sách người dùng
                window.location.href = "Task 32.50 load all users.html";
                console.log(JSON.stringify(paramResponse, true, 2));
            },
            error: function(ajaxContext){
                console.log(ajaxContext);
            }
        });
    }
    //hàm thu thập User id đang gửi request hiện tại
    function getCurrentUserId(){
        var vId = null;
        var vUrl = new URL(window.location.href) //url trở thành một obj
        //get parameters
        vId = vUrl.searchParams.get("id");
        return vId;
    }
    //hàm gọi api để lấy thông tin user dựa trên id
    function callApiGetUserById(paramId){
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + paramId,
            type: "GET",
            dataType: "json",
            success: function(res){
                console.log(res);
                loadDataToForm(res);
            },
            error: function(ajaxContext){
                console.log(ajaxContext.responseText);
            } 
        })
    }
    //hàm load dữ liệu lên form dựa
    function loadDataToForm(paramRes){
        $("#inp-firstname").val(paramRes.firstname);
        $("#inp-lastname").val(paramRes.lastname);
        $("#inp-subject").val(paramRes.subject);
        $("#select-country").val(paramRes.country);
        $("#select-customer").val(paramRes.customerType);
        $("#select-register").val(paramRes.registerStatus);
    }
</script>
</html>